import cv2
import numpy as np
import math

# Base parametres
inverse = True      # if generate also inverse pictures (default True)

# Projector resolution
x_proj = 640
y_proj = 360

# color definition
white = 255     # for use with opencv
black = 0

# script start
#-----------------------------------------------------------------

# min ^2 int for x pixels
x_rel = 2
number_of_x_pictures = 1
while (x_proj > x_rel):
    x_rel *= 2
    number_of_x_pictures += 1

# min ^2 int for y pixels
y_rel = 2
number_of_y_pictures = 1
while (y_proj > y_rel):
    y_rel *= 2
    number_of_y_pictures += 1

# initialization for image arrays
array = np.zeros([y_proj, x_proj])
array_inverse = np.zeros([y_proj, x_proj])

# set first
color = white

# code for columns
for i in range(number_of_x_pictures + 1):
    if i == 0:
        color = black
    else:
        color = white
    
    if i == 0:
        column_number = 1
    else:
        column_number *= 2

    pixel_number_width = x_rel/column_number
    for x in range(x_proj):
        for y in range(y_proj):
            if ((x/pixel_number_width == math.ceil(x/pixel_number_width)) & (y == 0)):
                if color == black:
                    color = white
                else:
                    color = black

            array[y, x] = color

            if inverse:
                if color == white:
                    array_inverse[y, x] = black
                else:
                    array_inverse[y, x] = white

    cv2.imwrite('binary_code/' + str((i*2)+1) + '.jpg', array)
    if inverse:
        cv2.imwrite('binary_code/' + str((i*2)+2) + '.jpg', array_inverse)


# code for rows
for i in range(number_of_y_pictures):
    color = white

    if i == 0:
        column_number = 2
    else:
        column_number *= 2

    pixel_number_width = y_rel/column_number
    for y in range(y_proj):
        for x in range(x_proj):
            if ((y/pixel_number_width == math.ceil(y/pixel_number_width)) & (x == 0)):
                if color == black:
                    color = white
                else:
                    color = black

            array[y, x] = color

            if inverse:
                if color == white:
                    array_inverse[y, x] = black
                else:
                    array_inverse[y, x] = white

    # save pictures with opencv
    cv2.imwrite('binary_code/' + str((i*2)+23) + '.jpg', array)
    if inverse:
        cv2.imwrite('binary_code/' + str((i*2)+24) + '.jpg', array_inverse)