import Adafruit_BBIO.GPIO as GPIO
import time

# script should be loaded on BBB (~/turntable/turntable.py)

steps = 64      # 512 - one turn
delay = 10      # ms

# GPIO pins
coil_A_1_pin = "P8_10" # pink
coil_A_2_pin = "P8_9" # orange
coil_B_1_pin = "P8_8"  # blue
coil_B_2_pin = "P8_7" # yellow
 
# sequence definition
StepCount = 8
Seq = range(0, StepCount)
Seq[0] = [GPIO.LOW, GPIO.HIGH,GPIO.LOW, GPIO.LOW ]
Seq[1] = [GPIO.LOW, GPIO.HIGH,GPIO.LOW, GPIO.HIGH]
Seq[2] = [GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.HIGH]
Seq[3] = [GPIO.HIGH,GPIO.LOW, GPIO.LOW, GPIO.HIGH]
Seq[4] = [GPIO.HIGH,GPIO.LOW, GPIO.LOW, GPIO.LOW ]
Seq[5] = [GPIO.HIGH,GPIO.LOW, GPIO.HIGH,GPIO.LOW ]
Seq[6] = [GPIO.LOW, GPIO.LOW, GPIO.HIGH,GPIO.LOW ]
Seq[7] = [GPIO.LOW, GPIO.HIGH,GPIO.HIGH,GPIO.LOW ]

# set pins outputs
GPIO.setup(coil_A_1_pin, GPIO.OUT)
GPIO.setup(coil_A_2_pin, GPIO.OUT)
GPIO.setup(coil_B_1_pin, GPIO.OUT)
GPIO.setup(coil_B_2_pin, GPIO.OUT)

def setStep(w1, w2, w3, w4):
    GPIO.output(coil_A_1_pin, w1)
    GPIO.output(coil_A_2_pin, w2)
    GPIO.output(coil_B_1_pin, w3)
    GPIO.output(coil_B_2_pin, w4)
 
def forward(delay, steps):
    for i in range(steps):
        for j in range(StepCount):
            setStep(Seq[j][0], Seq[j][1], Seq[j][2], Seq[j][3])
            time.sleep(delay)

# main
delay = delay/1000.0
forward(delay, steps)
setStep(GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.LOW)